# Contributing to nvm

Thanks for contributing to `nvm`!

We love pull requests and issues, they're our favorite.

However, before submitting, please review the following:

For bug reports:
 - Please make sure the bug is reproducible, and give us the steps to reproduce it, so that we can dig into the problem.
 - Please give us as much detail as possible about your environment, so we can more easily confirm the problem.

For pull requests:
 - Please include tests. Changes with tests will be merged very quickly.
 - Please manually confirm that your changes work in `bash`, `sh`/`dash`, `ksh`, and `zsh`. Fast tests do run in these shells, but it's nice to manually verify also.
 - Please maintain consistent whitespace - 2-space indentation, trailing newlines in all files, etc.
 - Any time you make a change to your PR, please rebase freshly on top of master. Nobody likes merge commits.

Even if you don't have all of these items covered, please still feel free to submit a PR/issue! Someone else may be inspired and volunteer to complete it for you.

Thanks again!

## Code of Conduct

The [Node.js Code of Conduct][] applies to this repo.

[Node.js Code of Conduct]: https://github.com/nodejs/node/blob/master/CODE_OF_CONDUCT.md

## Code Contributions

The nvm project falls under the governance of the post-mortem
working group which is documented in:
https://github.com/nodejs/post-mortem/blob/master/GOVERNANCE.md

## Developer's Certificate of Origin 1.1

By making a contribution to this project, I certify that:

* (a) The contribution was created in whole or in part by me and I
  have the right to submit it under the open source license
  indicated in the file; or

* (b) The contribution is based upon previous work that, to the best
  of my knowledge, is covered under an appropriate open source
  license and I have the right under that license to submit that
  work with modifications, whether created in whole or in part
  by me, under the same open source license (unless I am
  permitted to submit under a different license), as indicated
  in the file; or

* (c) The contribution was provided directly to me by some other
  person who certified (a), (b) or (c) and I have not modified
  it.

* (d) I understand and agree that this project and the contribution
  are public and that a record of the contribution (including all
  personal information I submit with it, including my sign-off) is
  maintained indefinitely and may be redistributed consistent with
  this project or the open source license(s) involved.
